
# display, extcon, power, usb are always enabled

#Just For debugging
%define sdb_prestart off

Name:       deviced
Summary:    Deviced
Version:    2.0.0
Release:    1
Group:      System/Management
License:    Apache-2.0
Source0:    %{name}-%{version}.tar.gz
Source1:    deviced.manifest
Source2:    libdeviced.manifest

BuildRequires:  cmake
BuildRequires:  libattr-devel
BuildRequires:  gettext-devel
BuildRequires:  pkgconfig(ecore)
BuildRequires:  pkgconfig(vconf)
BuildRequires:  pkgconfig(dlog)
BuildRequires:  pkgconfig(device-node)
BuildRequires:  pkgconfig(edbus)
BuildRequires:  pkgconfig(capi-base-common)
BuildRequires:  pkgconfig(dbus-1)
BuildRequires:  pkgconfig(dbus-glib-1)
BuildRequires:  pkgconfig(libudev)
BuildRequires:  pkgconfig(gio-2.0)
BuildRequires:  pkgconfig(glib-2.0)
BuildRequires:	pkgconfig(eventsystem)
BuildRequires:  pkgconfig(libtzplatform-config)
BuildRequires:  pkgconfig(hwcommon)
BuildRequires:  pkgconfig(capi-system-info)
BuildRequires:  pkgconfig(argos_watchdog)
BuildRequires:  pkgconfig(libsystemd)
BuildRequires:  pkgconfig(libinput)
BuildRequires:	pkgconfig(capi-system-sensor)
BuildRequires:	pkgconfig(fuse)
BuildRequires:	pkgconfig(minizip)
BuildRequires:	pkgconfig(libkmod)
BuildRequires:	pkgconfig(libusbgx)
BuildRequires:	pkgconfig(tapi)
BuildRequires:	pkgconfig(storage)

Requires: %{name}-tools = %{version}-%{release}
%{?systemd_requires}
Requires(post): /usr/bin/vconftool

Requires:	%{name}-compat = %{version}-%{release}
Recommends:	%{name}-profile_common = %{version}-%{release}

%description
deviced

# if profile = common or undefined
%package profile_common
Summary:	Deviced binaries targeting common profile
Provides:	%{name}-compat = %{version}-%{release}
Conflicts:	%{name}-profile_mobile
Conflicts:	%{name}-profile_wearable
Conflicts:	%{name}-profile_tv
Conflicts:	%{name}-profile_ivi
%description profile_common
Deviced binaries targeting common profile. Required by main deviced package.
# if profile = mobile or common or undefined
%package profile_mobile
Summary:	Deviced binaries targeting mobile profile
Provides:	%{name}-compat = %{version}-%{release}
Conflicts:	%{name}-profile_common
Conflicts:	%{name}-profile_wearable
Conflicts:	%{name}-profile_tv
Conflicts:	%{name}-profile_ivi
%description profile_mobile
Deviced binaries targeting mobile profile. Required by main deviced package
# if profile = wearable or common or undefined
%package profile_wearable
Summary:	Deviced binaries targeting wearable profile
Provides:	%{name}-compat = %{version}-%{release}
Conflicts:	%{name}-profile_common
Conflicts:	%{name}-profile_mobile
Conflicts:	%{name}-profile_tv
Conflicts:	%{name}-profile_ivi
%description profile_wearable
Deviced binaries targeting wearable profile. Required by main deviced package
# if profile = tv or common or undefined
%package profile_tv
Summary:	Deviced binaries targeting tv profile
Provides:	%{name}-compat = %{version}-%{release}
Conflicts:	%{name}-profile_common
Conflicts:	%{name}-profile_mobile
Conflicts:	%{name}-profile_wearable
Conflicts:	%{name}-profile_ivi
%description profile_tv
Deviced binaries targeting tv profile. Required by main deviced package

%package profile_ivi
Summary:	Deviced binaries targeting ivi profile
Provides:	%{name}-compat = %{version}-%{release}
Conflicts:	%{name}-profile_common
Conflicts:	%{name}-profile_mobile
Conflicts:	%{name}-profile_wearable
Conflicts:	%{name}-profile_tv
%description profile_ivi
Deviced binaries targeting ivi profile. Required by main deviced package.

%package tools
Summary:  Deviced tools
Group:    System/Utilities

%description tools
Deviced helper programs.
Deviced-tools is profile-independent; i.e., every profile has the same
binary for deviced-tools.

%package -n libdeviced
Summary:    Deviced library
Group:      Development/Libraries
Requires:   %{name} = %{version}-%{release}

%description -n libdeviced
Deviced library for device control.
Libdeviced is profile-independent; i.e., every profile has the same
binary for libdeviced.

%package -n libdeviced-devel
Summary:    Deviced library for (devel)
Group:      Development/Libraries
Requires:   libdeviced = %{version}-%{release}

%description -n libdeviced-devel
Deviced library for device control (devel).
Because this is internal interface, every profile MUST have the same
devel package.

%prep
%setup -q

%ifarch %{arm} aarch64
	%define ARCH arm
%endif

%ifarch %{arm} %ix86
	%define ARCH_BIT 32
%else
	%define ARCH_BIT 64
%endif

%if 0%{?tizen_build_devel_mode} == 1
%define engineer_mode on
%else
%define engineer_mode off
%endif

# Build per profile
# if profile = mobile or common or undefined
mkdir -p build_mobile
pushd build_mobile
%cmake .. \
	-DTZ_SYS_ETC=%TZ_SYS_ETC \
	-DCMAKE_INSTALL_PREFIX=%{_prefix} \
	-DARCH=%{ARCH} \
	-DARCH_BIT=%{ARCH_BIT} \
	-DDPMS=%{DPMS} \
	-DENGINEER_MODE=%{engineer_mode} \
	-DPROFILE=mobile \
	-DBATTERY_MODULE=on \
	-DDISPLAY_MODULE=on \
	-DEXTCON_MODULE=on \
	-DIR_MODULE=on \
	-DLED_MODULE=on \
	-DPOWER_MODULE=on \
	-DSDB_PRESTART=%{sdb_prestart} \
	-DTOUCHSCREEN_MODULE=on \
	-DTZIP_MODULE=on \
	-DUSB_MODULE=on \
	-DUSBHOST_MODULE=on \
	-DTIZEN_FEATURE_USBHOST_TEST=on \
	-DTIZEN_FEATURE_BATTERY_OVER_TEMPERATURE=off \
	-DTIZEN_FEATURE_CPU_MODULE=on \
	-DTIZEN_FEATURE_TELEPHONY_MODULE=on \
	-DTHERMAL_MODULE=on \
	#eol
popd

# if profile = wearable or common or undefined
mkdir -p build_wearable
pushd build_wearable
%cmake .. \
	-DTZ_SYS_ETC=%TZ_SYS_ETC \
	-DCMAKE_INSTALL_PREFIX=%{_prefix} \
	-DARCH=%{ARCH} \
	-DARCH_BIT=%{ARCH_BIT} \
	-DDPMS=%{DPMS} \
	-DENGINEER_MODE=%{engineer_mode} \
	-DPROFILE=wearable \
	-DBATTERY_MODULE=on \
	-DDISPLAY_MODULE=on \
	-DEXTCON_MODULE=on \
	-DIR_MODULE=off \
	-DLED_MODULE=off \
	-DPOWER_MODULE=on \
	-DSDB_PRESTART=%{sdb_prestart} \
	-DTOUCHSCREEN_MODULE=on \
	-DTZIP_MODULE=on \
	-DUSB_MODULE=on \
	-DUSBHOST_MODULE=off \
	-DTIZEN_FEATURE_USBHOST_TEST=off \
	-DTIZEN_FEATURE_BATTERY_OVER_TEMPERATURE=off \
	-DTIZEN_FEATURE_CPU_MODULE=off \
	-DTIZEN_FEATURE_TELEPHONY_MODULE=off \
	-DTHERMAL_MODULE=on \
	#eol
popd

# if profile = tv or common or undefined
mkdir -p build_tv
pushd build_tv
%cmake .. \
	-DTZ_SYS_ETC=%TZ_SYS_ETC \
	-DCMAKE_INSTALL_PREFIX=%{_prefix} \
	-DARCH=%{ARCH} \
	-DARCH_BIT=%{ARCH_BIT} \
	-DENGINEER_MODE=%{engineer_mode} \
	-DPROFILE=tv \
	-DBATTERY_MODULE=off \
	-DDISPLAY_MODULE=on \
	-DEXTCON_MODULE=on \
	-DIR_MODULE=off \
	-DLED_MODULE=off \
	-DPOWER_MODULE=on \
	-DSDB_PRESTART=%{sdb_prestart} \
	-DTOUCHSCREEN_MODULE=off \
	-DTZIP_MODULE=off \
	-DUSB_MODULE=on \
	-DUSBHOST_MODULE=on \
	-DTIZEN_FEATURE_USBHOST_TEST=off \
	-DTIZEN_FEATURE_BATTERY_OVER_TEMPERATURE=off \
	-DTIZEN_FEATURE_CPU_MODULE=off \
	-DTIZEN_FEATURE_TELEPHONY_MODULE=off \
	-DTHERMAL_MODULE=off \
	#eol
popd

# if profile = common or undefined
mkdir -p build_common
pushd build_common
%cmake .. \
	-DTZ_SYS_ETC=%TZ_SYS_ETC \
	-DCMAKE_INSTALL_PREFIX=%{_prefix} \
	-DARCH=%{ARCH} \
	-DARCH_BIT=%{ARCH_BIT} \
	-DDPMS=%{DPMS} \
	-DENGINEER_MODE=%{engineer_mode} \
	-DPROFILE=common \
	-DBATTERY_MODULE=off \
	-DDISPLAY_MODULE=on \
	-DEXTCON_MODULE=on \
	-DIR_MODULE=off \
	-DLED_MODULE=off \
	-DPOWER_MODULE=on \
	-DSDB_PRESTART=%{sdb_prestart} \
	-DTOUCHSCREEN_MODULE=off \
	-DTZIP_MODULE=off \
	-DUSB_MODULE=on \
	-DUSBHOST_MODULE=off \
	-DTIZEN_FEATURE_USBHOST_TEST=off \
	-DTIZEN_FEATURE_BATTERY_OVER_TEMPERATURE=off \
	-DTIZEN_FEATURE_CPU_MODULE=off \
	-DTIZEN_FEATURE_TELEPHONY_MODULE=off \
	-DTHERMAL_MODULE=off \
	#eol
popd

mkdir -p build_ivi
pushd build_ivi
%cmake .. \
	-DTZ_SYS_ETC=%TZ_SYS_ETC \
	-DCMAKE_INSTALL_PREFIX=%{_prefix} \
	-DARCH=%{ARCH} \
	-DARCH_BIT=%{ARCH_BIT} \
	-DDPMS=%{DPMS} \
	-DENGINEER_MODE=%{engineer_mode} \
	-DPROFILE=ivi \
	-DBATTERY_MODULE=off \
	-DDISPLAY_MODULE=on \
	-DEXTCON_MODULE=on \
	-DHAPTIC_MODULE=off \
	-DSTANDARD_MIX=%{standard_mix} \
	-DIR_MODULE=off \
	-DLED_MODULE=off \
	-DPOWER_MODULE=on \
	-DSDB_PRESTART=%{sdb_prestart} \
	-DTOUCHSCREEN_MODULE=off \
	-DTZIP_MODULE=off \
	-DUSB_MODULE=on \
	-DUSBHOST_MODULE=off \
	-DTIZEN_FEATURE_USBHOST_TEST=off \
	-DTIZEN_FEATURE_BATTERY_OVER_TEMPERATURE=off \
	-DTIZEN_FEATURE_CPU_MODULE=off \
	-DTIZEN_FEATURE_TELEPHONY_MODULE=off \
	-DTHERMAL_MODULE=off \
	#eol
popd

%build
cp %{SOURCE1} .
cp %{SOURCE2} .


# Build per profile
# if profile = mobile or common or undefined
pushd build_mobile
make %{?jobs:-j%jobs}
popd

# if profile = wearable or common or undefined
pushd build_wearable
make %{?jobs:-j%jobs}
popd

# if profile = tv or common or undefined
pushd build_tv
make %{?jobs:-j%jobs}
popd

# if profile = common or undefined
pushd build_common
make %{?jobs:-j%jobs}
popd

pushd build_ivi
make %{?jobs:-j%jobs}
popd

%install
rm -rf %{buildroot}
# Build per profile
# if profile = mobile or common or undefined
pushd build_mobile
%make_install
mv %{buildroot}%{_bindir}/deviced %{buildroot}%{_bindir}/deviced.mobile
popd

# if profile = wearable or common or undefined
pushd build_wearable
%make_install
mv %{buildroot}%{_bindir}/deviced %{buildroot}%{_bindir}/deviced.wearable
popd

# if profile = tv or common or undefined
pushd build_tv
%make_install
mv %{buildroot}%{_bindir}/deviced %{buildroot}%{_bindir}/deviced.tv
popd

# if profile = common or ivi or undefined
pushd build_common
%make_install
mv %{buildroot}%{_bindir}/deviced %{buildroot}%{_bindir}/deviced.common
popd

pushd build_ivi
%make_install
mv %{buildroot}%{_bindir}/deviced %{buildroot}%{_bindir}/deviced.ivi
popd

%install_service multi-user.target.wants deviced.service
%install_service sockets.target.wants deviced.socket
# usb_module condition is removed because it is always on
%if %{?sdb_prestart} == on
%install_service basic.target.wants sdb-prestart.service
%endif

mkdir -p %{buildroot}%{_prefix}/lib/udev/rules.d
install -m 644 udev/99-usbhost.rules %{buildroot}%{_prefix}/lib/udev/rules.d/99-usbhost.rules

mkdir -p %{buildroot}%{TZ_SYS_DUMPGEN}
install -m 775 scripts/dump_pmstate_log.sh %{buildroot}%{TZ_SYS_DUMPGEN}/dump_pmstate_log.sh

%post
#memory type vconf key init
users_gid=$(getent group %{TZ_SYS_USER_GROUP} | cut -f3 -d':')

%postun
systemctl daemon-reload

%post -n libdeviced -p /sbin/ldconfig

%postun -n libdeviced -p /sbin/ldconfig

%post profile_mobile
mv %{_bindir}/deviced.mobile %{_bindir}/deviced
mv %{_sysconfdir}/deviced/display-mobile.conf %{_sysconfdir}/deviced/display.conf

systemctl daemon-reload
if [ "$1" == "1" ]; then
    systemctl restart deviced.service
fi

%preun profile_mobile
mv %{_bindir}/deviced %{_bindir}/deviced.mobile

if [ "$1" == "0" ]; then
    systemctl stop deviced.service
fi

%post profile_wearable
mv %{_bindir}/deviced.wearable %{_bindir}/deviced
mv %{_sysconfdir}/deviced/display-wearable.conf %{_sysconfdir}/deviced/display.conf

systemctl daemon-reload
if [ "$1" == "1" ]; then
    systemctl restart deviced.service
fi

%preun profile_wearable
mv %{_bindir}/deviced %{_bindir}/deviced.wearable

if [ "$1" == "0" ]; then
    systemctl stop deviced.service
fi

%post profile_tv
mv %{_bindir}/deviced.tv %{_bindir}/deviced
mv %{_sysconfdir}/deviced/display-tv.conf %{_sysconfdir}/deviced/display.conf
%preun profile_tv
mv %{_bindir}/deviced %{_bindir}/deviced.tv

%post profile_common
mv %{_bindir}/deviced.common %{_bindir}/deviced
mv %{_sysconfdir}/deviced/display-common.conf %{_sysconfdir}/deviced/display.conf
%preun profile_common
mv %{_bindir}/deviced %{_bindir}/deviced.common

%post profile_ivi
mv %{_bindir}/deviced.ivi %{_bindir}/deviced
mv %{_sysconfdir}/deviced/display-ivi.conf %{_sysconfdir}/deviced/display.conf
%preun profile_ivi
mv %{_bindir}/deviced %{_bindir}/deviced.ivi

%files
%manifest %{name}.manifest
%license LICENSE
%config %{_sysconfdir}/dbus-1/system.d/deviced.conf
%{_unitdir}/multi-user.target.wants/deviced.service
%{_unitdir}/sockets.target.wants/deviced.socket
%{_unitdir}/deviced.service
%{_unitdir}/deviced.socket
#%if %{?power_module} == on ==? always on
%config %{_sysconfdir}/deviced/power.conf
#%endif
#if #{?usb_module} == on ==> always on
%config %{_sysconfdir}/deviced/usb-operation.conf
%if %{?sdb_prestart} == on
%{_unitdir}/sdb-prestart.service
%{_unitdir}/basic.target.wants/sdb-prestart.service
%endif
#endif

%files profile_mobile
%manifest deviced.manifest
%license LICENSE
%{_bindir}/deviced.mobile
# TIZEN_FEATURE_LAZY_MOUNT == on
# battery_module
%config %{_sysconfdir}/deviced/battery.conf
# usbhost_module
%{_prefix}/lib/udev/rules.d/99-usbhost.rules
# usbhost_test
%{_sysconfdir}/deviced/usb-host-test/test_gadget.gs
%{_bindir}/usb-host-ffs-test-daemon
%{_unitdir}/usb-host-ffs-test-daemon.service
%{_unitdir}/usb-host-test.socket
%{_sysconfdir}/deviced/usb-host-test/descs
%{_sysconfdir}/deviced/usb-host-test/strs
# cpu_module
%config %{_sysconfdir}/deviced/cpu.conf
#if #{?display_module} == on ==> always on
%config %{_sysconfdir}/deviced/display-mobile.conf

%files profile_wearable
%manifest deviced.manifest
%license LICENSE
%{_bindir}/deviced.wearable
# battery_module
%config %{_sysconfdir}/deviced/battery.conf
#if #{?display_module} == on ==> always on
%config %{_sysconfdir}/deviced/display-wearable.conf

%files profile_tv
%manifest deviced.manifest
%license LICENSE
%{_bindir}/deviced.tv
# usbhost_module
%{_prefix}/lib/udev/rules.d/99-usbhost.rules
#if #{?display_module} == on ==> always on
%config %{_sysconfdir}/deviced/display-tv.conf

%files profile_common
%manifest deviced.manifest
%license LICENSE
%{_bindir}/deviced.common
#if #{?display_module} == on ==> always on
%config %{_sysconfdir}/deviced/display-common.conf

%files profile_ivi
%manifest deviced.manifest
%license LICENSE
%{_bindir}/deviced.ivi
#if #{?display_module} == on ==> always on
%config %{_sysconfdir}/deviced/display-ivi.conf

%files tools
%manifest deviced.manifest
%license LICENSE
%{_bindir}/devicectl
#if #{?usb_module} == on ==> always on
%{_bindir}/direct_set_debug.sh
%{TZ_SYS_DUMPGEN}/dump_pmstate_log.sh
#endif

%files -n libdeviced
%manifest deviced.manifest
%license LICENSE
%defattr(-,root,root,-)
%{_libdir}/libdeviced.so.*

%files -n libdeviced-devel
%defattr(-,root,root,-)
%{_includedir}/deviced/*.h
%{_libdir}/libdeviced.so
%{_libdir}/pkgconfig/deviced.pc
